
local event= CreateFrame("frame")
event:RegisterEvent("ADDON_LOADED")
local spot=0
local cani, found, Numskills
local done=false

local function pauseit()
	spot=0
	Bt_TrainAll()
end

function Bt_TrainAll()
	if done==true then
		spot=0
		return
	end
	Numskills=GetNumTrainerServices()
	found=false
	while found==false do
		spot=spot+1
		_,_,cani=GetTrainerServiceInfo(spot)
		if cani=="available" then
			BuyTrainerService(spot)
			C_Timer.After(0.3,pauseit)
			found=true
		end
		if spot>=Numskills then
			done=true
			break
		end
	end
end



local function createit()
	local Button = CreateFrame("Button", "TrainAllButton",ClassTrainerFrame, "MagicButtonTemplate")
	Button:SetText("Train All")
	Button:SetPoint("BOTTOMRIGHT",-96,4)
	Button:SetScript("OnEnter", function()
	GameTooltip:SetOwner(Button,"ANCHOR_RIGHT")
	GameTooltip:SetText("Train All available skills\nHold Shift to train all skills Instantly")
	end)
	Button:SetScript("OnLeave", function()
	GameTooltip:Hide()
	end)
	Button:SetScript("ONClick",function() if IsShiftKeyDown() then BuyTrainerService(0) else spot=0 done=false Bt_TrainAll()end end)
	if IsAddOnLoaded("ElvUI") then
		local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
		local S = E:GetModule('Skins')
		S:HandleButton(Button,1)
	end
	hooksecurefunc("ClassTrainerFrame_Update",function()
		for i=1, GetNumTrainerServices() do
			local _,_,cani=GetTrainerServiceInfo(i)
			if cani=="available" then
				TrainAllButton:Enable()
				return
			end
		end
		TrainAllButton:Disable()
	end)
end

local function woho(_,_,name)
	if name=="TrainAll" then
		if IsAddOnLoaded("Blizzard_TrainerUI") then
			createit()
			event:UnregisterEvent("ADDON_LOADED")
		end
	elseif name=="Blizzard_TrainerUI" then
		createit()
		event:UnregisterEvent("ADDON_LOADED")
	end
end

event:SetScript("OnEvent", woho)
